%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% binary_comb:
%
% Generates all possible combinations of values for a 0/1 binary sample
% space.
%
% Input:
%
% - num_y: dimensionality of the data
%   
% Output:
% 
% - Y: dataset
%
% Created by: Ricardo Silva, London, 21/02/2012
% University College London
% Current version: 21/02/2012

function Y = binary_comb(num_y)

num_comb = 2^num_y;
Y = zeros(num_comb, num_y);

value = zeros(1, num_y);

for i = 2:num_comb
  for y = num_y:-1:1
    if value(y) == 0
      value(y) = 1;
      break
    end
    value(y) = 0;
  end
  Y(i, :) = value;
end

